# directory.c File Reference

`#include <ubixfs/ubixfs.h>`
`#include <vfs/file.h>`
`#include <vfs/mount.h>`
`#include <ubixos/types.h>`
`#include <lib/kmalloc.h>`
`#include <lib/kprintf.h>`
`#include <lib/string.h>`

Include dependency graph for directory.c:

Go to the source code of this file.

## Functions

int | addDirEntry (struct directoryEntry *dir, fileDescriptor *fd)
dirList_t | ubixFSLoadDir (char *data)
int | ubixFSmkDir (char *directory, fileDescriptor *fd)

## Variables

static dirList_t | dirList = 0x0

## Function Documentation

int addDirEntry | ( | struct directoryEntry * | dir,
|  | fileDescriptor * | fd |
| ) |  |  |

Definition at line 66 of file directory.c.

References kmalloc(), kprintf(), memcpy(), fileDescriptorStruct::offset, readUbixFS(), fileDescriptorStruct::size, writeUbixFS(), and x1000.

Referenced by ubixFSmkDir().

Here is the call graph for this function:

dirList_t ubixFSLoadDir | ( | char * | data | ) |

Definition at line 41 of file directory.c.

References directoryList::dirCache, dirList, directoryList::dirName, kmalloc(), directoryList::next, directoryList::prev, sprintf(), and strcmp().

Here is the call graph for this function:

int ubixFSmkDir | ( | char * | directory,
|  | fileDescriptor * | fd |
| ) |  |  |

Definition at line 94 of file directory.c.

References addDirEntry(), directoryEntry::attributes, ubixFSInfo::blockAllocationTable, blockSize, vfs_mountPoint::device, device_node::devInfo, vfs_mountPoint::diskLabel, directoryEntry::fileName, vfs_mountPoint::fsInfo, getFreeBlocks(), device_interface::info, kfree(), kmalloc(), fileDescriptorStruct::mp, vfs_mountPoint::partition, ubixDiskLabel::partitions, directoryEntry::permissions, blockAllocationTableEntry::realSector, directoryEntry::size, sprintf(), directoryEntry::startCluster, typeDirectory, UBIXFS_BLOCKSIZE_BYTES, and device_interface::write.

Referenced by ubixfs_init().

Here is the call graph for this function:

## Variable Documentation

dirList_t dirList = 0x0`[static]`

Definition at line 38 of file directory.c.

Referenced by ubixfs_cacheFind(), ubixfs_findName(), and ubixFSLoadDir().